package com.docus.server.common;

import com.docus.infrastructure.core.db.Sort;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

public interface IService<T> {

    T findById(Serializable id);

    List<T> findByIds(Collection<Serializable> ids);

    List<T> findBy(String propertyName, Object propertyValue);

    List<T> findByList(String propertyName, Collection<?> propertyValue);

    List<T> findActiveBy(String propertyName, Object propertyValue);

    List<T> findBy(String propertyName, Object propertyValue, Sort sort);

    List<T> findActiveBy(String propertyName, Object propertyValue, Sort sort);

    T findOneBy(String propertyName, Object propertyValue);

    T findOneByList(String propertyName, Collection<?> propertyValue);

    T findActiveOneBy(String propertyName, Object propertyValue);

    List<T> findAll();

    List<T> findAllActive();

    List<T> findAll(Sort sort);

    List<T> findAllActive(Sort sort);

    int deleteByIdList(List<Serializable> idList);

    boolean saveBatch(Collection<T> entityList, int batchSize);

    boolean saveOrUpdate(T entity);

    boolean updateBatchById(Collection<T> entityList, int batchSize);

    boolean saveOrUpdateBatch(Collection<T> entityList, int batchSize);
}
